; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 440
WINDOWHEIGHT = 400
num     equ 45
star	struct
	red	db ?
	green	db ?
	blue	db ?
	dist	dd ?
	angle	dd ?;sizeof star=11
star	ends
BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS
BITMAPINFOHEADER STRUCT
  biSize          dd ?
  biWidth         dd ?
  biHeight        dd ?
  biPlanes        dw ?
  biBitCount      dw ?
  biCompression   dd ?
  biSizeImage     dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	FSize:dword
local	szReadWrite:QWORD	;number of bytes actually read or write


        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_TIMER
	je      wmTIMER
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	mov	ecx,texture
	invoke	GlobalFree
	invoke	GlobalFree,stars
	invoke	RtlExitUserProcess,NULL
;----------------------------------------------
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	cmp	al,VK_T
	jne	@f
	xor	twinkle,1
	jmp	wmTIMER
@@:	cmp	al,VK_PRIOR;Page Up
	movss	xmm0,zoom
	movss	xmm1,const0_2
	jne	@f
	subss	xmm0,xmm1;  
	jmp	@3
@@:	cmp	al,VK_NEXT;Page Down 
	jne	@f
	addss	xmm0,xmm1;  
@3:	movss	zoom,xmm0
	jmp	wmTIMER
@@:	cmp	al,VK_UP
	movss	xmm0,tilt
  	movss	xmm1,LightAmbient
	jne	@f
	subss	xmm0,xmm1; xspeed
	jmp	@2
@@:	cmp	al,VK_DOWN
	jne	wmBYE
	addss	xmm0,xmm1; xspeed
@2:	movss	tilt,xmm0
wmTIMER:invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
;-------------------------------------------------------
        invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,num*(sizeof star)
	mov	stars,rax
	mov	ecx,offset FileName2
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,\
        FILE_FLAG_SEQUENTIAL_SCAN,0;;FILE_ATTRIBUTE_ARCHIVE,0
        mov	esi,eax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax				; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	texture,eax
        mov	edi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,esi,eax,FSize,,rbx
        invoke	CloseHandle,esi
	mov	esi,edi
        add	esi,[rdi + BITMAPFILEHEADER.bfOffBits]
	lea	edi,[rdi + sizeof BITMAPFILEHEADER]
	mov	eax,[rdi + BITMAPINFOHEADER.biWidth]
        mov	w,eax
        movzx	eax, word ptr [rdi + BITMAPINFOHEADER.biHeight]
        mov	h,eax
;--------------------------------------------------------------
	mov	edx,offset Texture1_Id
	invoke	glGenTextures,1
;    
	invoke	glBindTexture,GL_TEXTURE_2D,Texture1_Id
	mov	r9d,w
        mov	eax,h
	invoke	glTexImage2D,GL_TEXTURE_2D,0,3,,rax,rbx,GL_BGR_EXT,GL_UNSIGNED_BYTE,rsi
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR

        invoke	glEnable,GL_TEXTURE_2D;enable texture mapping (the img is 2D)
	invoke	glShadeModel,GL_SMOOTH;smooth shading
	cvtss2sd xmm0,LightDiffuse;=1.0
	invoke	glClearDepth;   
	movss	xmm3,LightAmbient
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;    

;     ()
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST
        invoke	glBlendFunc,GL_SRC_ALPHA,GL_ONE;Set The Blending Function For Translucency
	invoke	glEnable,GL_BLEND

	xor	edi,edi
	mov	rsi,stars
@@:	mov	[rsi+rdi+star.angle],ebx
	cvtsi2ss xmm0,edi;edi=i*11
	divss	xmm0,const110;float(i)/num)*5.0=i*5/50=i/10
	movss	[rsi+rdi+star.dist],xmm0
	invoke	rand
	mov	[rsi+rdi+star.red],al
	invoke	rand
	mov	[rsi+rdi+star.green],al
	invoke	rand
	mov	[rsi+rdi+star.blue],al
	add	edi,sizeof star
	cmp	edi,num*(sizeof star)
	jb	@b
;     
	invoke	glMatrixMode,GL_PROJECTION;     ()
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT

	movd	xmm6,LightDiffuse;=1.0
	xorps	xmm7,xmm7
	subss	xmm7,xmm6

        invoke	glBindTexture,GL_TEXTURE_2D,Texture1_Id
	xor	edi,edi; Loop Through All The Stars
	mov	rsi,stars
@0:	invoke	glLoadIdentity;Reset The View Before We Draw Each Star
	movss	xmm2,zoom
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;0,0,zoom	 Zoom Into The Screen (Using The Value In 'zoom')
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,xmm6
	movss	xmm0,tilt
	invoke	glRotatef;tilt,1.0,0,0	 Tilt The View (Using The Value In 'tilt')
	xorps	xmm3,xmm3
	movss	xmm2,xmm6
	xorps	xmm1,xmm1
	movss	xmm0,[rsi+rdi+star.angle]
	invoke	glRotatef;stars[rdi].angle,0,1.0,0	 Rotate To The Current Stars Angle
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,[rsi+rdi+star.dist]
	invoke	glTranslatef;stars[rdi].dist,0,0	 Move Forward On The X Plane
	xorps	xmm3,xmm3
	movss	xmm2,xmm6
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	subss	xmm0,[rsi+rdi+star.angle]
	invoke	glRotatef;-stars[rdi].angle,0,1.0,0 Cancel The Current Stars Angle
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,xmm6
	xorps	xmm0,xmm0
	subss	xmm0,tilt
	invoke	glRotatef;-tilt,1.0,0,0		 Cancel The Screen Tilt
		
	cmp	twinkle,0
	jz	@f
	mov	eax,(num-1)*(sizeof star)
	sub	eax,edi
	mov	r9b,255
	mov	r8b,[rsi+rax+star.blue]
	mov	dl,[rsi+rax+star.green]
	mov	cl,[rsi+rax+star.red]
	invoke	glColor4ub
	invoke	glBegin,GL_QUADS
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 0
	xorps	xmm2,xmm2
	movss	xmm1,xmm7
	movss	xmm0,xmm7
 	invoke	glVertex3f;(-1.0,-1.0, 0
	xorps	xmm1,xmm1
	movss	xmm0,xmm6
	invoke	glTexCoord2f;1.0, 0
	xorps	xmm2,xmm2
	movss	xmm1,xmm7
	movss	xmm0,xmm6
	invoke	glVertex3f; 1.0,-1.0, 0
	movss	xmm1,xmm6
	movss	xmm0,xmm6
	invoke	glTexCoord2f;1.0, 1.0
	xorps	xmm2,xmm2
	movss	xmm1,xmm6
	movss	xmm0,xmm6
	invoke	glVertex3f; 1.0, 1.0, 0
	movss	xmm1,xmm6
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 1.0
	xorps	xmm2,xmm2
	movss	xmm1,xmm6
	movss	xmm0,xmm7
 	invoke	glVertex3f;(-1.0, 1.0, 0
	invoke	glEnd;
@@:	movss	xmm3,xmm6
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,spin
	invoke	glRotatef;spin,0,0,1.0
	mov	r9b,255
	mov	r8b,[rsi+rdi+star.blue]
	mov	dl,[rsi+rdi+star.green]
	mov	cl,[rsi+rdi+star.red]
	invoke	glColor4ub
	invoke	glBegin,GL_QUADS;
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 0
	xorps	xmm2,xmm2
	movss	xmm1,xmm7
	movss	xmm0,xmm7
 	invoke	glVertex3f;-1.0,-1.0, 0
	xorps	xmm1,xmm1
	movss	xmm0,xmm6
	invoke	glTexCoord2f;1.0, 0
	xorps	xmm2,xmm2
	movss	xmm1,xmm7
	movss	xmm0,xmm6
 	invoke	glVertex3f;1.0,-1.0, 0
	movss	xmm1,xmm6
	movss	xmm0,xmm6
	invoke	glTexCoord2f;1.0, 1.0
	xorps	xmm2,xmm2
	movss	xmm1,xmm6
	movss	xmm0,xmm6
 	invoke	glVertex3f; 1.0, 1.0, 0
	movss	xmm1,xmm6
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 1.0
	xorps	xmm2,xmm2
	movss	xmm1,xmm6
	movss	xmm0,xmm7
	invoke	glVertex3f;-1.0, 1.0, 0
	invoke	glEnd;
	movss	xmm0,spin
	addss	xmm0,const0_01
	movss	spin,xmm0;spin+=0.01f;
	cvtsi2ss xmm0,edi
	divss	xmm0,const550;edi=i*11 xmm0=i/50=i*11/550	
	movss	xmm1,[rsi+rdi+star.angle];stars[rdi].angle+=float(i)/num
	addss	xmm1,xmm0
	movss	[rsi+rdi+star.angle],xmm1;stars[rdi].angle+=float(i)/num
	movss	xmm0,[rsi+rdi+star.dist]
	subss	xmm0,const0_01
	movss	[rsi+rdi+star.dist],xmm0;stars[rdi].dist-=0.01f;
	movd	eax,xmm0
	or	eax,eax
	jns	@f;if (stars[rdi].dist< 0 )
	addss	xmm0,const5;stars[rdi].dist+=5.0;
	movss	[rsi+rdi+star.dist],xmm0
	invoke	rand
	mov	[rsi+rdi+star.red],al;stars[rdi].red=rand%256
	invoke	rand
	mov	[rsi+rdi+star.green],al;stars[rdi].green=rand%256;
	invoke	rand
	mov	[rsi+rdi+star.blue],al;stars[rdi].blue=rand%256;
@@:	add	edi,sizeof star
	cmp	edi,num*(sizeof star)
	jb	@0
        invoke  glFlush
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson #9: Moving Bitmaps in 3D-Space",0
FileName	db "br_Rabbit3.cur",0
FileName2	db "star.bmp",0
zoom		dd -15.0  ;Distance Away From Stars
tilt		dd 90.0   ;Tilt The View
spin		dd ?      ;Spin Stars
stars		dq ?
Texture1_Id	dq ?
twinkle		db 0
texture		dd ?
;-----------------------------
;float
const0_01	dd 0.01
const0_2	dd 0.2
const5		dd 5.0
const110	dd 110.0
const550	dd 550.0
;double
constd0_1	dq 0.1
constd45	dq 45.0
constd100	dq 100.0
LightAmbient    dd 0.5,0.5,0.5,1.0
LightDiffuse    dd 4 dup (1.0)
LightPosition   dd 0.0,0.0,2.0,1.0
end